#
# spec file for package ghc-effect-handlers
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name effect-handlers
%bcond_with tests
Name:           ghc-%{pkg_name}
Version:        0.1.0.8
Release:        1.11
Summary:        A library for writing extensible algebraic effects and handlers. Similar to extensible-effects but with deep handlers
License:        MIT
Group:          System/Libraries
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
# Begin cabal-rpm deps:
BuildRequires:  ghc-free-devel
BuildRequires:  ghc-kan-extensions-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-rpm-macros
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if %{with tests}
BuildRequires:  ghc-HUnit-devel
BuildRequires:  ghc-QuickCheck-devel
BuildRequires:  ghc-hspec-devel
BuildRequires:  ghc-hspec-discover-devel
%endif
# End cabal-rpm deps

%description
This is an extensible effects library for Haskell taking inspiration from the
Eff language <http://www.eff-lang.org/>.

See these papers for the ideas and theory behind the library:

- O. Kammar et al: Handlers in Action!
<http://homepages.inf.ed.ac.uk/slindley/papers/handlers.pdf> - A.
Bauer, M. Pretnar: Programming with Algebraic Effects and Handlers
<http://arxiv.org/abs/1203.1539> - O Kiselyov, A Sabry, C Swords: Extensible
Effects <http://dl.acm.org/citation.cfm?id=2503791>

Implementation wise it's most close to 'extensible-effects'
<http://hackage.haskell.org/package/extensible-effects> (also see the
Extensible Effects paper) but it implements deep handlers instead of shallow.

' import Control.Effects.Cont.Eff import Control.Effects.Cont.Reader import
Control.Effects.Cont.Exception

program = do &#32;&#32;v <- ask &#32;&#32;if v < 15 &#32;&#32;then throw $ show
v &#32;&#32;else return (v+1)

run n = runPure . handle exceptionHandler . handle (readerHandler n)

res :: Integer -> Either String Integer res n = run n program '.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development
files.

%prep
%setup -q -n %{pkg_name}-%{version}


%build
%ghc_lib_build


%install
%ghc_lib_install


%check
%if %{with tests}
%{cabal} test
%endif


%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%defattr(-,root,root,-)
%doc LICENSE

%files devel -f %{name}-devel.files
%defattr(-,root,root,-)
%doc README.md

%changelog
* Sun Jul 10 2016 psimons@suse.com
- Update to version 0.1.0.8 revision 0 with cabal2obs.
